.text
.thumb

save_registers:
push	{r1-r7}

find_who_called_font_routine:
push	{lr}
pop		{r0}
adr		r1, link_address_color_pairs

match_link_register_with_color_table:
ldr		r2, [r1]
cmp		r2, #0
beq		default_color
cmp		r0, r2
beq		found_color
add		r1, #8
b			match_link_register_with_color_table

found_color:
ldr		r0, [r1, #4]
b			chosen_color

default_color:
mov		r0, #0x1f
lsl		r1, r0, #10
add		r0, r0, r1

chosen_color:

restore_registers:
pop		{r1-r7}

store_color:
str		r0, [sp, #36]

replaced_code:
sub		sp, #36
add		r4, r2, #0
mov		r0, #0
str		r0, [sp, #24]
ldr		r0, old_font_address
bx		r0

.align

old_font_address:
.word 0x8003211

link_address_color_pairs:
.word 0x80044f3, 0x0001 @dialog title shadow
.word 0x8004513, 0x1c22 @dialog title text
.word 0x8003607, 0x0001 @dialog text
.word 0x8000fe3, 0x0001 @version shadow
.word 0x8000ff7, 0x7fff @version text
.word 0x8005b5b, 0x0001 @filemanager scrolling selected text
.word 0x800626d, 0x0001 @filemanager selected text
.word 0x80067d9, 0x0001 @filemanager selected text
.word 0x8006afb, 0x0001 @filemanager selected text
.word 0x8006187, 0x7fff @filemanager unselected size
.word 0x80066c9, 0x7fff @filemanager unselected size
.word 0x8006a27, 0x7fff @filemanager unselected size
.word 0x8005f9d, 0x7fff @filemanager unselected text
.word 0x8006591, 0x7fff @filemanager unselected text
.word 0x80068ef, 0x7fff @filemanager unselected text
.word 0x8009439, 0x7fff @options unselected text
.word 0x80094a3, 0x0001 @options selected text
.word 0x800b5b7, 0x7fff @text viewer text
.word 0x800b685, 0x7fff @text viewer text
.word 0x800b70b, 0x7fff @text viewer text
.word 0x80050e1, 0x0001 @"Time" shadow
.word 0x80050f5, 0x1c22 @"Time" text
.word 0x8005265, 0x0001 @"Load" shadow
.word 0x8005279, 0x1c22 @"Load" text

.word 0

